const genRanHex = size => [...Array(size)].map(() => Math.floor(Math.random() * 16).toString(16)).join('');
const sessionStr = () => {
    if (!localStorage.getItem('session'))
        localStorage.setItem('session', genRanHex(64));
    return localStorage.getItem('session');
};
const sessionState = async () => {
    const response = await fetch(
        `/state/?session=${sessionStr()}`
    );
    return await response.json();
};
const sessionStatus = (
    () => {
        let task;
        return (async () => {
            if (task === undefined) {
                task = (async () => {
                    const response = await fetch(
                        `/status/?session=${sessionStr()}`
                    );
                    return await response.json();
                })();
            }
            return await task;
        })
    }
)();
const root = document.querySelector('#root');
const logEl = (msg) => {
    const el = document.createElement('pre');
    el.innerText = msg;
    root.append(el);
};
const sessionClient = async () => {
    const session = await sessionStatus();
    return session && session['client'];
};
const sessionUser = async () => {
    const client = await sessionClient();
    return client && client['user'];
};
const userAvatarUrl = async () => {
    const user = await sessionUser();
    return user && user['avatar'];
};
const userUsername = async () => {
    const user = await sessionUser();
    return user && user['username'];
};
const userAvatarImg = async () => {
    const img = document.createElement('img');
    img.src = await userAvatarUrl();
    img.width = 128;
    img.height = 128;
    img.alt = await userUsername();
    return img;
};
